;IPLWARE 
;----------------------------------------------------------------------------
; PC-9821Gen1..Gen4 IDE BIOS patch Version 1.20 (C) 2024 ܂
;----------------------------------------------------------------------------
include macros.inc

; Global stack variables -----------------
COLOR_ATTRIB    equ     byte ptr [bp-2] ; \F
ROW             equ     word ptr [bp-4] ; \s
COLUMN          equ     word ptr [bp-6] ; \J
SegTVRAM        equ     word ptr [bp-8] ; T-VRAM̃ZOgA000/E000
HiresoFlag      equ     byte ptr [bp-10] ; 01h Hi-reso flag (bit 0)
CheckFlags      equ     byte ptr [bp-11] ;
TypeIDEBIOS     equ     byte ptr [bp-12] ; 
ModeID          equ     byte ptr [bp-13] ; ݂̃p[^[h
equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
MemWindowAddr   equ     byte ptr [bp-15] ; 08-BANK window address in EXROM
MemWindowNative equ     byte ptr [bp-16] ; 08-BANK window native address
MachineID       equ     byte ptr [bp-17] ; Machine ID
SECTOR_N        equ     byte ptr [bp-18]
HEAD_N          equ     byte ptr [bp-19]
ChipsetType     equ     byte ptr [bp-20]

mem_bank_IOaddr equ     word ptr [bp-22] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-24] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-26] ; IDE BIOSZOgiRAMmappingj
Seg9821         equ     word ptr [bp-28] 
SegTemp         equ     word ptr [bp-30] 

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
title_msg0      DB      0E5h," IDE foCX̕CHSp[^̕ύX  Version 1.20  Copyright (C) 2024 ܂ ",13,10,0
title_msg1      DB      0E1h,"'PC-98Őɓ삵ȂIDEfoCX(CFȂ)gp\ɂ.",13,10,0
title_msg2      DB      0E1h,"@                                                  ",0
title_msg3      DB      0E1h,"s, ܂͑ΉłȂ.",0
.8086
program_start:  
                push    bp
                mov     bp,sp
                sub     sp,34   ; X^bNϐm 34 bytes

                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     TypeIDEBIOS,al  ; =0
                mov     CheckFlags,al
                mov     ChipsetType,al
                mov     SegTemp,MEM_SEG

                mov     COLOR_ATTRIB,0E1h
                mov     SECTOR_N,63
                mov     HEAD_N,16
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                cld                     ; ^,RAMIDE BIOSZOg𓾂 

                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                mov     ax,ROW
                mov     dx,offset title_msg0    ; ^Cg\
                call    _puts
                mov     dx,offset title_msg1    ; ^Cg\
                call    _puts
                mov     dx,offset title_msg2
                call    _puts
                mov     COLUMN,6
                
                call    CheckEPSONPC
                jc      WrongMachine
                
                call    ModelCheck21    ; F8E8:3Fh @ID
                pushf   ; Returned DX is the model name.
                call    _puts
                popf
                jc      WrongMachine


                test    CheckFlags,ALREDY_PATCHED
                jz      @f
                mov     dx,offset already_done
                call    _puts
;;;                jmp     ExitProgram
        @@:     mov     dx,offset msg_CRLF
                call    _puts
                call    Scan_GRPH_FK_1516
                jc      ToAvoid
                call    CheckMemSwitch  ; XCb`̃[hݒ擾
                jc      AvoidPatch      ; CY=G[ŏI

                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~
                
                test    CheckFlags,PCIBUS       ; V1.20
                jnz     @f
                test    CheckFlags,REDWOOD      ; V1.20
                jnz     @f
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~
        @@:
                push    cs
                pop     ax
                cmp     ax,6000h
                jne     @f
                mov     dx,1E8Eh
                mov     al,81h
                out     dx,al
@@:
                test    CheckFlags,PCIBUS
                jnz     @f
                call    DisplayEquip
        @@:
                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB
                
                test    CheckFlags,PCIBUS
                jz      @f
                call    PCI_Check
        @@:
                mov     ax,SegTemp
                mov     es,ax   ; esƗp ES=MEMseg, DS=CS
                cmp     TypeIDEBIOS,30h
                je      Gene3Patch
                cmp     TypeIDEBIOS,40h
                je      Gene4Patch
                cmp     TypeIDEBIOS,41h
                je      Gene41Patch
;Gene1_2Patch:
                call    pattern02patch    ; IDE BIOS 0`2@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene3Patch:
                call    pattern3patch    ;  3@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene4Patch:
                call    pattern4patch    ;  4@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
Gene41Patch:
                call    pattern41patch    ;  4PCI@̃pb`
                jnc     EndOfPatch
                jmp     WrongBIOS
; N/A
                JMP     WrongMachine
EndOfPatch:   ; call    SetChkSum
                mov     al,CheckFlags
                test    al,PCIBUS
                jz      @f
                call    MEMtoIDEBIOS_PCI ; ̍ƌʂRAM BIOSɃRs[
                jmp     ExitProgram
        @@:
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
                call    SetReentFlag    ; V1.20
ExitProgram:    call    ClearSegTemp     ; ƃNAđދ
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~
                mov     ax,0380h
                int     1Bh
                mov     sp,bp
                pop     bp

                RET    ; near ^[ŏI
;                mov     ah,4Ch
;                int     21h

;--------------- Abnormal end ----------------------------
WrongMachine:   
                mov     dx,offset wrong_msg 
                call    _puts           ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
ToAvoid:        mov     dx,offset msg_CTRL
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      
                call    Poop ; ````
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     
                mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts

                jmp     ExitProgram
;----------------------------------------------------------------------------
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXN̐ڑj"
CRLF_msg        DB      20h,13,10,0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_CTRL        DB     0E5h,"CTRL܂ [F7]Ă̂",0
already_done    DB     081h,"  Ƀpb`ς݂̂悤ł. ",0
msg_AvoidPatch  DB     0E5h," pb`𒆎~܂. ",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0
;--------------------------------------------------------
;--------------------------------------------------------
SetReentFlag    PROC   near
                push    ds
                mov     bx,0455h
                xor     ax,ax
                mov     ds,ax
                mov     al,ds:[bx]
                or      al,00000010b
                mov     ds:[bx],al
                pop     ds
                ret
SetReentFlag    ENDP
;--------------------------------------------------------
;       machine dependent BIOS pattern
;--------------------------------------------------------
Ptn_IDP_Sect   label word
                mov     byte ptr es:[2000h],07h
                mov     byte ptr es:[2001h],00h
                mov     byte ptr es:[200Ah],11h
Ptn_IDP_Sect_end    label word

Ptn_IDP_Head    label   word
               or       byte ptr es:[2004h],03h
               DB       0EBh,07h
               nop
               or       byte ptr es:[2004h],07h
Ptn_IDP_Head_end    label   word

;--------------------------------------------------------

include pat02Gim.s
include pat3G_im.s
include pat4G_im.s
include pat4GAim.s

;--------------------------------------------------------
.386

;--------------------------------------------------------
;       MEMtoIDEBIOS_PCI   5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS_PCI      PROC   near
                call    D800_RAM
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                mov     es,SegPhysIDEBIOS
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                popf
                call    D800_WP
                ret     ; G[Ԓl͂Ȃ
MEMtoIDEBIOS_PCI      ENDP
.8086
;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                mov     es,SegMMapIDEBIOS
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ
MEMtoIDEBIOS    ENDP

;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                cld
                mov     cx,2000h/2      ; 8KB
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,SegTemp
                push    ds
                mov     ds,ax   ; ds=SegTemp, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                cld
                mov     cx,2000h/2      ; 8KB
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,SegTemp
                push    es
                push    ds
                mov     es,ax   ; ES=AX=SegTemp
                mov     ds,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
          rep   movsw
                pop     ds
                pop     es
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------
include     Machine.inc
include     ideptcom.inc
include     pcibus.inc
include     numeric.inc     ; l\[`
include     putstrj3.s      ; \[`

;----------------------------------
code    ends
        end     start
