;------------------------------------------------------------
;       ModelCheck21    
;------------------------------------------------------------
ModelCheck21    PROC   near
                mov     al,MachineID
                cmp     al,00h ; Ap-Ae
                je      Machine_A1
                cmp     al,01h ; mod. BX,BA
                je      Machine_B1
                cmp     al,0FFh ; 
                je      IDEBIOS_0Gen

                cmp     al,05h ; Af
                je      Machine_A2
                cmp     al,06h ; Ap2,As2 
                je      Machine_A2

                cmp     al,07h  ; B2
                je      Machine_B2
                cmp     al,08h  ; Ce2,Cs2
                je      Machine_C2
                cmp     al,09h  ;
                je      Machine_T2

                cmp     al,12h ; X-mate
                je      Machine_X3
                cmp     al,13h ; X-mate/PCI(Xa,Xt,Xf)
                je      Machine_X3PCI
                cmp     al,16h ; B3-FELOW
                je      Machine_B3
                cmp     al,15h ; Cx,Cb
                je      Machine_B3
                cmp     al,18h ; A2
                je      Machine_A3
                cmp     al,14h ; ES
                je      Machine_ES
                cmp     al,22h 
                je      IDEBIOS_4Gen
                cmp     al,29h 
                je      IDEBIOS_4Gen

                test    CheckFlags,PCIBUS
                jnz     Machine_PCI4

                mov     dx,offset title_msg3
                JMP     IDEBIOS_unknown
                
Machine_A1:     mov     dx,offset mac_A1
                or      CheckFlags,SND_AM1
                jmp     IDEBIOS_1Gen
Machine_B1:     mov     dx,offset mac_B1
                jmp     IDEBIOS_1Gen
Machine_C1:     mov     dx,offset mac_C1
                or      CheckFlags,SND_AM1
                jmp     IDEBIOS_1Gen
                
Machine_A2:     mov     dx,offset mac_A2
                jmp     IDEBIOS_2Gen
Machine_B2:     mov     dx,offset mac_B2
                jmp     IDEBIOS_2Gen
Machine_C2:     mov     dx,offset mac_C2
                jmp     IDEBIOS_2Gen
Machine_T2:     mov     dx,offset mac_T2
                jmp     IDEBIOS_2Gen

Machine_A3:     mov     dx,offset mac_A3
                jmp     IDEBIOS_3Gen
Machine_B3:     mov     dx,offset mac_B3
                jmp     IDEBIOS_3Gen
Machine_C3:     mov     dx,offset mac_C3
                jmp     IDEBIOS_3Gen
Machine_X3:     mov     dx,offset mac_X3
                jmp     IDEBIOS_3Gen
Machine_X3PCI:  mov     dx,offset mac_X3PCI
                jmp     IDEBIOS_3Gen
Machine_ES:     mov     dx,offset mac_ES
                jmp     IDEBIOS_3Gen
Machine_PCI4:   mov     dx,offset mac_PCI4
                jmp     IDEBIOS_4GenP

IDEBIOS_0Gen:   mov     dx,offset mac_00
                clc
                ret
IDEBIOS_1Gen:   or      TypeIDEBIOS,10h
                clc
                ret
IDEBIOS_2Gen:   or      TypeIDEBIOS,20h
                or      CheckFlags,SND_DSW
                clc
                ret
IDEBIOS_3Gen:   mov     TypeIDEBIOS,30h
                or      CheckFlags,SND_DSW
                clc
                ret
IDEBIOS_4Gen:   mov     dx,offset mac_B4XE
                mov      TypeIDEBIOS,40h
                or      CheckFlags,SND_DSW
                clc
                ret
IDEBIOS_4GenP:  or      TypeIDEBIOS,41h
                clc
                ret
IDEBIOS_unknown:   
                mov     TypeIDEBIOS,00h
                stc
                ret
mac_PCI4        DB      0E1h,"PC-9821 series PCI chipset machine",0
mac_B4XE        DB      0E1h,"PC-9821 Xe10, PC-9801 BX4",0
mac_X3PCI       DB      0E1h,"PC-9821 Xa,Xt,(Xf)",0
mac_X3          DB      0E1h,"PC-9821 Xn,Xp,Xs,Xe",0
mac_ES          DB      0E1h,"PC-9821 Es",0
mac_C3          DB      0E1h,"PC-9821 Cx,Cb",0
mac_B3          DB      0E1h,"PC-9821 BA3,BX3",0
mac_A3          DB      0E1h,"PC-9821 Ap3,As3",0

mac_T2          DB      0E1h,"PC-9821Ts",0
mac_C2          DB      0E1h,"PC-9821Ce2,Cs2 (Multi)",0
mac_B2          DB      0E1h,"B-FELLOW, B-mate Be,Bs,Bp",0
mac_A2          DB      0E1h,"A-mate Af,Ap2,As2",0

mac_C1          DB      0E1h,"PC-9821Ce multi",0
mac_B1          DB      0E1h,"B-FELLOW BX,BA",0
mac_A1          DB      0E1h,"PC-9821 Ae,As,Ap",0
mac_00          DB      0A1h,"m肳ĂȂ̂Ŏs܂.",13,10,0

ModelCheck21    ENDP

;--------------------------------------2022/2/1-----
;       CheckEPSONPC
;---------------------------------------------------
CheckEPSONPC    PROC   near
                xor     ax,ax
                mov     es,ax
                mov     ax,0FD80h       ; seg
                mov     bx,0002h        ; ofs
                mov     cx,2A27h        ; EPSON 27h,2Ah (Normal)
                test    byte ptr es:[0501h],8
                jz      EpsonNormalMode
                mov     ax,0F800h       ; seg
                mov     bx,07F70h       ; ofs
                mov     cx,1827h        ; EPSON 27h,18h (Hireso)
EpsonNormalMode:  
                mov     es,ax
                cmp     es:[bx],cx      ; compare
                je      IsEPSONPC
                clc
                ret
IsEPSONPC:      
                mov     al,es:[3]       ; EPSON ID
                mov     ah,0
;;                or      flagset,F_EPSON
                stc     ; CY=EPSON PC
                ret
CheckEPSONPC    ENDP

