.386

MachineVLSI     equ     4
MachineRCC      equ     2
MachineIntel    equ     1
Machine450KX    equ     9

;-----------------------------------
PCIset          PROC    near
                push    ax
                mov     eax,80000000h
                pop     ax
                mov     dx,0CF8h
                out     dx,eax
                mov     dx,0CFCh
                in      eax,dx
                ret
PCIset          ENDP
;----------------------------------------------

;----------------------------------------------
;       D800_RAM(PCI)
;----------------------------------------------
D800_RAM        PROC   near
                mov     cl,ChipsetType
                cmp     cl,MachineVLSI
                je      D800_RAM4

                cmp     cl,MachineRCC
                je      D800_RAM2

                mov     ax,0A05Ch
                cmp     cl,Machine450KX
                je      D800_RAM_ST20

                mov     ax,005Ch
                cmp     cl,MachineIntel
                je      D800_RAM1
                stc
                ret
D800_RAM4:   
                mov     ax,0064h        ; reg 67h
                call    PCIset
                ror     eax,16
                push    ax
                and     ax,3000h        ; 3000
                mov     ch,ah
                pop     ax
                or      ax,3000h
                rol     eax,16
                jmp     D800_RAME

D800_RAM2:      mov     ax,0070h        ; reg 72h
                call    PCIset
                ror     eax,16
                and     al,11001111b ; 
                or      al,00110000b
                rol     eax,16
                jmp     D800_RAME

D800_RAM_ST20:  call    PCIset          ; reg 5Dh
                or      ah,00000011b    ;
                out     dx,ax
                mov     ax,0C85Ch
                call    PCIset          ; reg 5Dh
                and     ah,11111100b
                jmp     D800_RAME

D800_RAM1:      call    PCIset          ; reg 5Dh
                or      ah,00000011b    ; Write enabled 
D800_RAME:      
                out     dx,eax
                clc
                ret
D800_RAM        ENDP
;-------------------------------------------
;       D800_WP (PCI)
;-------------------------------------------
D800_WP         PROC    near
                mov     cl,ChipsetType
 
                cmp     cl,MachineVLSI
                je      D800_WP4
;;                je      D800_WP_CANCEL

                cmp     cl,MachineRCC
                je      D800_WP2

                mov     ax,0A05Ch
                cmp     cl,Machine450KX
                je      D800_WP9

                mov     ax,005Ch
                cmp     cl,MachineIntel
                je      D800_WP1
D800_WP_CANCEL:
                stc
                ret

D800_WP4:       mov     ax,0064h        ; reg 67h
                call    PCIset
                and     eax,11101111111111111111111111111111b
                jmp     D800_WP_END
D800_WP2:       
                jmp     D800_WP_END

D800_WP9:       call    PCIset
                and     ah,11111101b ; reg 5Dh = MEMORY WP
                out     dx,ax
                mov     ax,0C05Ch
                call    PCIset
                or      ah,00000010b ; reg 5Dh = MEMORY WP
                jmp     D800_WP_END

D800_WP1:       call    PCIset
                and     ah,11110000b;
                or      ah,00000001b
D800_WP_END:   
                out     dx,eax
                clc
                ret
D800_WP         ENDP

;--------------------------------------------------------
;       PCI_Check
;--------------------------------------------------------
PCI_Check       PROC    near
if 0 ; BIOS not used
                cld
                xor     dx,dx
                mov     ax,0B101h       ; Get PCI BIOS status
                int     1Ah             ; PCI BIOS call
                jc      PCI_Check_fail
                cmp     dx,20494350h    ; ?dx=='PCI '
                jnz     PCI_Check_fail
endif
                mov     eax,80000000h
                mov     ChipsetType,al
                mov     bx,ax
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx

                cmp     ax,0FFFFFFFFh  ; non PCI chipset
                je      ChipSetNotExist

                cmp     ax,8086h       ; Intel chipset
                je      IntelChipSet

                cmp     eax,00051166h       ; RCC/NEC chipset
                je      RCC_ChipSet

                cmp     ax,1004h       ; VLSI_ChipSet
                je      VLSI_ChipSet

ChipSetNotExist: ; 
                mov     eax,8000C800h   ; Device No.25 , PC-9821St ?
                mov     dx,0CF8h
                out     dx,eax
                mov     dl,0FCh
                in      eax,dx
                cmp     eax,84C48086h   ; Device ID of 450KX host bridge
                jz      KX450_Chipset

PCI_Check_fail: STC                     ; Error Return 
                ret

VLSI_ChipSet:   mov     ChipsetType,MachineVLSI
                jmp     PCI_Check_OK


RCC_ChipSet:    mov     ChipsetType,MachineRCC
                jmp     PCI_Check_OK


KX450_Chipset:  mov     ChipsetType,Machine450KX
; V2.60 ;--------------ST
                 mov     eax,8000C850h ; PCI25[53h] ->02h
                 mov     dx,0CF8h
                 out     dx,eax
                 mov     dl,0FCh
                 in      eax,dx
                 rol     eax,8
                 or      al,02h
                 ror     eax,8
                 out     dx,eax

                 mov     eax,8000C854h ; PCI25[54h] ->6Bh
                 mov     dx,0CF8h
                 out     dx,eax
                 mov     dl,0FCh
                 in      eax,dx
                 or      al,01101011b  ; 29 -->6B   
                 out     dx,al

                 mov     eax,8000C8C0h ; PCI25[C0h] ->000000010h
                 mov     dx,0CF8h
                 out     dx,eax
                 mov     dl,0FCh
                 in      eax,dx
                 mov     eax,000000010h	
                 out     dx,al
;--------------ST
                jmp     PCI_Check_OK

IntelChipSet:   mov     ChipsetType,MachineIntel
PCI_Check_OK:   nop
                CLC
                ret
PCI_Check       ENDP

.8086
